<?php

class CentralpayOtpProcessModuleFrontController extends ModuleFrontController {

  protected $msg = "";

  protected $title = "";

  const CENTRALPAY = '_CENTRALPAY_';

  const CARD_ID='cardId';

  const ENROLLMENT_ID = 'enrollmentId';

  const TRANSACTION = 'transaction';

  const NOM_MODULE = 'centralpay';

  public function postProcess() {



    $sql = 'SELECT id_module FROM ' . _DB_PREFIX_ . 'module WHERE name=\'' . pSQL('centralpay') . '\'';
    $results = Db::getInstance()->ExecuteS($sql);

    $id_module = $results[0]["id_module"];
    if (Configuration::get(self::CENTRALPAY . 'MODE_TEST') == 1) {
      $url_api = API_TEST;

    }
    else {
      $url_api = API;

    }
    $otp = Tools::getValue("otp");


    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = Configuration::get(self::CENTRALPAY . 'LOGIN') . ":" . Configuration::get(self::CENTRALPAY . 'PASSWORD');

    /**
     * ADRESSE IP DU CLIENT
     */
    if (Configuration::get(self::CENTRALPAY . 'MODE_TEST') == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = Configuration::get(self::CENTRALPAY . 'IP');
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }



    $panier = $this->context->cart;
    /**
     * Récupération des données de la transaction
     */
    $trans = json_decode($this->context->cookie->transaction, 1);
    $retour3ds = json_decode($this->context->cookie->retour3DS, 1);

    if(is_array($retour3ds) && isset($retour3ds[self::ENROLLMENT_ID]) && isset($retour3ds[self::ENROLLMENT_ID])){

      $trans["3ds"]=array(self::ENROLLMENT_ID=>$retour3ds[self::ENROLLMENT_ID],"paRes"=>Tools::getValue('PaRes'));
    }

    $trans['otp'] = $otp;

    /**
     * Si on doit demander le cvc on redirige vers cvc
     */
    if($this->context->cookie->__get('cvc')==1){

      $this->context->cookie->__set(self::TRANSACTION, json_encode($trans));
      $link = $this->context->link->getModuleLink(self::NOM_MODULE, 'cvc');
      Tools::redirect($link);
      exit();

    }





    $transfields = isset($trans) ? http_build_query($trans) : null;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url_api . "transaction");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
    $result = curl_exec($curl);
    $info = curl_getinfo($curl);
    $retour = json_decode($result, 1);
    curl_close($curl);

    /**
     * Vérification de l'état de la transaction
     */

    if (isset($info["http_code"]) && $info["http_code"] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
      //transaction ok
      //on transforme le panier en commande validée et payée
      $cart = new Cart((int) $panier->id);
      $order_status = (int) Configuration::get('PS_OS_PAYMENT');
      $order_total = $cart->getOrderTotal(TRUE, Cart::BOTH);
      $this->module->validateOrder($panier->id, $order_status, $order_total, $this->module->l('Credit/Debit card', $this->module->name), NULL, ['transaction_id' => $retour["transactionId"]], NULL, FALSE, $panier->secure_key);
      /**
       * Enregistrement de la liaison entre le paiement et la carte centralpay
       */
      $orderid = Order::getOrderByCartId((int) ($cart->id));

      $order = new Order($orderid);
      if ($this->context->cookie->saveCard == 1) {
        $sql = 'SELECT * FROM ' . _DB_PREFIX_ . 'order_payment WHERE order_reference=\'' . pSQL($order->reference) . '\'';
        $results = Db::getInstance()->ExecuteS($sql);
        if (is_array($results)) {
          foreach ($results as $r) {
            if ($r["transaction_id"] == $retour["transactionId"]) {
              Db::getInstance()->insert('centralpay_payment_card', [
                self::CARD_ID => pSQL($trans[self::CARD_ID]),
                'cmsPaymentId' => pSQL($r["id_order_payment"]),
              ]);


            }


          }


        }
      }
      $this->context->cookie->__unset('transaction');
      $this->context->cookie->__unset(self::CARD_ID);
      $this->context->cookie->__unset('customerValidationValue');
      $this->context->cookie->__unset('retour3DS');
      $link = 'index.php?controller=order-confirmation&id_cart=' . $order->id_cart
        . '&id_module=' . $id_module . '&id_order=' . $order->id
        . '&key=' . $order->secure_key;
      Tools::redirect($link);

    }
    else {

      //on transforme le panier en commande erreur de paiement
      $link = $this->errorCommande();
      Tools::redirect($link);

    }


  }


  public function errorCommande() {

    $sql = 'SELECT * FROM ' . _DB_PREFIX_ . 'module WHERE name=\'' . pSQL('centralpay') . '\'';
    $results = Db::getInstance()->ExecuteS($sql);

    $id_module = $results[0]["id_module"];


    $panier = $this->context->cart;
    $cart = new Cart((int) $panier->id);
    $order_status = (int) Configuration::get('PS_OS_ERROR');
    $order_total = $cart->getOrderTotal(TRUE, Cart::BOTH);
    $this->module->validateOrder($panier->id, $order_status, $order_total, $this->module->l('Credit/Debit card', $this->module->name), NULL, [], NULL, FALSE, $panier->secure_key);
    $orderid = Order::getOrderByCartId((int) ($cart->id));

    $order = new Order($orderid);
    return 'index.php?controller=order-confirmation&id_cart=' . $order->id_cart
      . '&id_module=' . $id_module . '&id_order=' . $order->id
      . '&key=' . $order->secure_key . '&error=yes';

  }

}