var cardIcon = [{
        type: "cc-maestro",
        patterns: [5018, 502, 503, 506, 56, 58, 639, 6220, 67],
        length: [12, 13, 14, 15, 16, 17, 18, 19]
    }, {
        type: "cc-forbrugsforeningen",
        patterns: [600],
        length: [16]
    }, {
        type: "cc-dankort",
        patterns: [5019],
        length: [16]
    }, {
        type: "cc-visa",
        patterns: [4],
        length: [13, 16]
    }, {
        type: "cc-mastercard",
        patterns: [51, 52, 53, 54, 55, 22, 23, 24, 25, 26, 27],
        length: [16]
    }, {
        type: "cc-amex",
        patterns: [34, 37],
        length: [15]
    }, {
        type: "cc-diners-club",
        patterns: [30, 36, 38, 39],
        length: [14]
    }, {
        type: "cc-discover",
        patterns: [60, 64, 65, 622],
        length: [16]
    }, {
        type: "cc-unionpay",
        patterns: [62, 88],
        length: [16, 17, 18, 19]
    }, {
        type: "cc-jcb",
        patterns: [35],
        length: [16]
    }];

function iconCard(number) {
    // Remove spaces and hyphens
    number = (number + "").replace(/\s+|-/g, "");
    var card, p, pattern, i, j, len, len1, ref;
    for (i = 0, len = cardIcon.length; i < len; i++) {
        card = cardIcon[i];
        ref = card.patterns;
        for (j = 0, len1 = ref.length; j < len1; j++) {
            pattern = ref[j];
            p = pattern + "";
            if (number.substr(0, p.length) === p) {
                return card.type;
            }
        }
    }
}

function updateCardNumberIcon() {
    var num = document.getElementById("num");
    var parentNode = num.parentNode;
    // Remove existing cardIcon
    var cardIcon = parentNode.querySelector('.cardIcon');
    if (cardIcon) {
        parentNode.removeChild(cardIcon);
    }
    var newCardIcon = iconCard(num.value);
    if (newCardIcon) {
        // New cardIcon
        var spanIcon = document.createElement('span');
        spanIcon.className = "cardIcon "+newCardIcon;
        parentNode.appendChild(spanIcon);
    }
    if(jQuery('#num').val().length==19){
        jQuery("#month").focus();
    }
}
var champsForm;
function setMask(){
    if( jQuery("#num").length>0){
        initForm();

        jQuery("#num").payment("formatCardNumber");
        jQuery("#month").inputmask('Regex',{ regex : "^(0[1-9]|1[0-2])$" });
        jQuery("#year").inputmask('Regex',{ regex : "^[0-9][0-9]$" });
        jQuery("#cvv2").payment("formatCardCVC");
        jQuery("#cvv3").payment("formatCardCVC");
        clearInterval(champsForm);
    }
}


var currentForm;
var defaultHandlerCP = function (status, response) {
    var divErrors = document.querySelector('[data-centralpay="errors"]');
    divErrors.innerHTML = "";
    var hasError = false;
    $('.error').remove();
    if (status != 200) { // Error
        var ulErrors = document.createElement('ul');
        var liErrors;

        if (status == 400) {
            var json = JSON.parse(response);
            if (json && json.errors) { // Bad Request with json response errors
                for (var key in json.errors) {
                    if(key=='card[*]'){
                        jQuery('#cpay-exp-wrapper').after('<div class="error">'+json.errors[key]+'</div>');
                    }
                    if(key=='card[cvc]'){
                        jQuery('#div_cvv').after('<div class="error">'+json.errors[key]+'</div>');
                    }
                    if(key=='card[number]'){
                        jQuery('#num_carte .input-group').after('<div class="error">'+json.errors[key]+'</div>');
                    }
                }
            } else {
                // Other errors
                liErrors = document.createElement('li');
                liErrors.appendChild(document.createTextNode('An error was occured'));
                ulErrors.appendChild(liErrors);
                hasError = true;
            }
        } else {
            // Other errors
            liErrors = document.createElement('li');
            liErrors.appendChild(document.createTextNode('An error was occured'));
            ulErrors.appendChild(liErrors);
            hasError = true;
        }

        if(hasError) {
            divErrors.appendChild(ulErrors);
        }else{
            $('.payment-errors').html('');
        }
        // Re-enable submission
        jQuery('[type="submit"]').removeAttr('disabled');
    }
    else {
        // Token was created
        var token = JSON.parse(response);
        // Insert cardTokenId in the form
        var inputTokenId = document.createElement('input');
        inputTokenId.setAttribute('type', 'hidden');
        inputTokenId.setAttribute('name', 'cardTokenId');
        inputTokenId.value = token.cardTokenId;
        document.querySelector('form[data-centralpay="form"]').appendChild(inputTokenId);
        // Remove submit event
        document.querySelector('form[data-centralpay="form"]').removeEventListener('submit', defaultHandlerCP);
        // Submit the form
        document.querySelector('form[data-centralpay="form"]').submit();
    }
};


function initForm(){
    var form = document.querySelector('form[data-centralpay="form"]');
    if (form && form.nodeName === "FORM") {
        form.addEventListener('submit', function(e) {
            $('.payment-errors').html('');
            // Prevent other event listener
            Centralpay.utils.safePreventEvent(e);
            // Disable the submit button of the form to prevent repeated clicks
            jQuery('[type="submit"]').attr('disabled', 'disabled');
            // Request a token from Centralpay
            Centralpay.card.createToken(form, defaultHandlerCP);
            return false;
        });
    }
}


$(document).ready(function () {

    //initialisation();
    $('#div_centralpay').livequery(function(){

        initialisation();
    });

   /* $('body').on('DOMNodeInserted','#div_centralpay', function (e) {
        $(e.target.nodeName).find('#saveCard').each(function() {
           // initialisation();
        });
    });*/


});


function initialisation(){

console.log('init');
    window.Centralpay ? Centralpay.card.setMerchantPublicKey(MerchantPublicKey):'';
    initForm();

    var columnContainer = jQuery('.columns-container');
    columnContainer.on('click','#link_centralpay',function() {
        jQuery('#div_centralpay').slideDown("slow");
    });

    columnContainer.on("keyup",'#num', updateCardNumberIcon);
    columnContainer.on("keyup",'#month', function(){
        if(jQuery(this).val().length==2){
            jQuery("#year").focus();
        }
    });
    columnContainer.on("keyup",'#year', function(){
        if(jQuery(this).val().length==2 && $(this).val().indexOf('_')==-1 ){
            jQuery("#cvv2").focus();
        }
    });

    jQuery('#cgv').on('click',function(){
        if(jQuery(this).prop('checked')==true){
            champsForm =  setInterval(function(){
                setMask();
            }, 1000);
        }
    });

    jQuery('#link_centralpay').on('click', function(e) {
        e.preventDefault();
        $('#cpay-payment').stop().slideToggle();
        $(this).stop().toggleClass('open');
    });

    jQuery('a[title]').qtip({position: {my: 'bottom center', at: 'top center'}});

    jQuery("#num").payment("formatCardNumber");
    jQuery("#month").inputmask('Regex',{ regex : "^(0[1-9]|1[0-2])$" });
    jQuery("#year").inputmask("99");
    jQuery("#cvv2").payment("formatCardCVC");
    jQuery("#cvv3").payment("formatCardCVC");

}